﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SmoothingScrollViewer
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : TianXiaTech.BlurWindow
    {
        public MainWindow()
        {
            InitializeComponent();

            for(int i = 0;i<50;i++)
            {
                this.list.Items.Add(i.ToString());
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Random r = new Random();
            var item = this.list.Items[r.Next(0, 50)];

            ListBoxItem listBoxItem = list.ItemContainerGenerator.ContainerFromItem(item) as ListBoxItem;

            // 获取选择元素的位置
            Point position = listBoxItem.TranslatePoint(new Point(0, 0), list);


            //滚动到指定位置
            this.scroll.ScrollToVerticalOffset(position.Y);
            this.list.SelectedItem = item;
        }

        private async void Button_Click_1(object sender, RoutedEventArgs e)
        {
            //ManualCalculateScroll();

            SmoothScroll();
        }

        private void SmoothScroll()
        {
            Random r = new Random();
            var item = this.list.Items[r.Next(0, 50)];

            ListBoxItem listBoxItem = list.ItemContainerGenerator.ContainerFromItem(item) as ListBoxItem;

            // 获取选择元素的位置
            Point position = listBoxItem.TranslatePoint(new Point(0, 0), list);

            this.scroll.ScrollToVerticalOffsetAnimated(position.Y);
            this.list.SelectedItem = item;
        }

        private async void ManualCalculateScroll()
        {
            Random r = new Random();
            var item = this.list.Items[r.Next(0, 50)];

            ListBoxItem listBoxItem = list.ItemContainerGenerator.ContainerFromItem(item) as ListBoxItem;

            // 获取选择元素的位置
            Point position = listBoxItem.TranslatePoint(new Point(0, 0), list);

            var gap = position.Y - this.scroll.VerticalOffset;

            //假设分5次
            var tick = (int)(gap / 5);
            int y = (int)this.scroll.VerticalOffset;

            for (int i = 0; i < 5; i++)
            {
                y += tick;
                this.scroll.ScrollToVerticalOffset(y);
                //缓慢滚动到指定位置
                await Task.Delay(50);
            }

            this.scroll.ScrollToVerticalOffset(position.Y);
            
            this.list.SelectedItem = item;
        }
    }
}
